"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
exports.createExact = exports.createOptions = void 0;
var Parser_1 = __importDefault(require("../error/Parser"));
var orElseThrow = function (t, isMatchingType, error) {
    if (isMatchingType()) {
        return t();
    }
    throw error();
};
var createOptions = function (_a) {
    var t = _a.t, expectedType = _a.expectedType, isMatchingType = _a.isMatchingType;
    return ({
        orElseGetNull: function () { return (!isMatchingType() ? null : t()); },
        orElseGetUndefined: function () { return (!isMatchingType() ? undefined : t()); },
        orElseGet: function (a) { return (!isMatchingType() ? a : t()); },
        orElseLazyGet: function (a) { return (!isMatchingType() ? a() : t()); },
        orElseThrowCustom: function (message) {
            return orElseThrow(t, isMatchingType, function () { return Parser_1["default"].custom(message); });
        },
        orElseThrowDefault: function (name) {
            return orElseThrow(t, isMatchingType, function () {
                return Parser_1["default"]["default"]({
                    name: name,
                    expectedType: expectedType,
                    value: t()
                });
            });
        }
    });
};
exports.createOptions = createOptions;
var createExact = function (_a) {
    var t = _a.t, e = _a.e, expectedType = _a.expectedType;
    return createOptions({
        t: function () { return t; },
        expectedType: expectedType,
        isMatchingType: function () { return t === e; }
    });
};
exports.createExact = createExact;
//# sourceMappingURL=index.js.map