"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
exports.__esModule = true;
exports.parseAsReadonlyArray = exports.parseAsArray = void 0;
var parser_1 = require("../parser");
var util_1 = require("../util");
var util_2 = require("./util");
var getActualType = function (u) {
    return Array.isArray(u) ? 'array' : (0, util_1.getPossibleSelfDefinedType)(u);
};
var parseAsAnArray = function (map, u, isImmutable) {
    return (0, parser_1.createDataStructureParser)({
        expectedType: 'array',
        actualType: getActualType(u),
        t: function () { return (0, util_2.freeze)(function () { return u.map(map); }, isImmutable); }
    });
};
var orElseGetEmptyArray = function (map, u, isImmutable) {
    return !(0, util_1.isEqual)(getActualType(u), 'array')
        ? [].map(map)
        : (0, util_2.freeze)(function () { return u.map(map); }, isImmutable);
};
var parseAsArray = function (u, map) { return (__assign(__assign({}, parseAsAnArray(map, u, false)), { orElseGetEmptyArray: function () { return orElseGetEmptyArray(map, u, false); } })); };
exports.parseAsArray = parseAsArray;
var parseAsReadonlyArray = function (u, map) { return (__assign(__assign({}, parseAsAnArray(map, u, true)), { orElseGetReadonlyEmptyArray: function () {
        return orElseGetEmptyArray(map, u, true);
    } })); };
exports.parseAsReadonlyArray = parseAsReadonlyArray;
//# sourceMappingURL=array.js.map