import { PossibleSelfDefinedType, ParameterlessLazyLoad } from '../types';
declare type Params<T> = Readonly<{
    t: T;
    expectedType: PossibleSelfDefinedType;
}>;
declare const createPrimitiveParser: <T>({ t, expectedType, isMatchingType, }: Readonly<{
    t: unknown;
    expectedType: PossibleSelfDefinedType;
}> & Readonly<{
    isMatchingType: () => boolean;
}>) => Readonly<{
    orElseGet: <U>(u: U) => T | U;
    orElseLazyGet: <U_1>(u: ParameterlessLazyLoad<U_1>) => T | U_1;
    orElseGetUndefined: () => T | undefined;
    orElseGetNull: () => T | null;
    orElseThrowDefault: (name: string) => T;
    orElseThrowCustom: (message: string) => T;
}>;
declare const createDataStructureParser: <T>({ t, expectedType, actualType, }: Readonly<{
    t: ParameterlessLazyLoad<T>;
    expectedType: PossibleSelfDefinedType;
}> & Readonly<{
    actualType: PossibleSelfDefinedType;
}>) => Readonly<{
    orElseGet: <U>(u: U) => T | U;
    orElseLazyGet: <U_1>(u: ParameterlessLazyLoad<U_1>) => T | U_1;
    orElseGetUndefined: () => T | undefined;
    orElseGetNull: () => T | null;
    orElseThrowDefault: (name: string) => T;
    orElseThrowCustom: (message: string) => T;
}>;
export { createPrimitiveParser, createDataStructureParser };
