declare const parseAsNull: (t: unknown) => Readonly<{
    orElseGet: <U>(u: U) => U | null;
    orElseLazyGet: <U_1>(u: import("../types").ParameterlessLazyLoad<U_1>) => U_1 | null;
    orElseGetUndefined: () => null | undefined;
    orElseGetNull: () => null;
    orElseThrowDefault: (name: string) => null;
    orElseThrowCustom: (message: string) => null;
}>;
declare const parseAsString: (t: unknown) => {
    orElseGetEmptyString: () => string;
    exactlyAs: <S extends string>(s: S) => {
        orElseGetEmptyString: () => string;
        orElseGet: <U>(u: U) => S | U;
        orElseLazyGet: <U_1>(u: import("../types").ParameterlessLazyLoad<U_1>) => S | U_1;
        orElseGetUndefined: () => S | undefined;
        orElseGetNull: () => S | null;
        orElseThrowDefault: (name: string) => S;
        orElseThrowCustom: (message: string) => S;
    };
    orElseGet: <U_2>(u: U_2) => string | U_2;
    orElseLazyGet: <U_3>(u: import("../types").ParameterlessLazyLoad<U_3>) => string | U_3;
    orElseGetUndefined: () => string | undefined;
    orElseGetNull: () => string | null;
    orElseThrowDefault: (name: string) => string;
    orElseThrowCustom: (message: string) => string;
};
declare const parseAsBoolean: (t: unknown) => {
    orElseGetTrue: () => boolean;
    orElseGetFalse: () => boolean;
    exactlyAs: <B extends boolean>(b: B) => {
        orElseGetTrue: () => boolean;
        orElseGetFalse: () => boolean;
        orElseGet: <U>(u: U) => B | U;
        orElseLazyGet: <U_1>(u: import("../types").ParameterlessLazyLoad<U_1>) => B | U_1;
        orElseGetUndefined: () => B | undefined;
        orElseGetNull: () => B | null;
        orElseThrowDefault: (name: string) => B;
        orElseThrowCustom: (message: string) => B;
    };
    orElseGet: <U_2>(u: U_2) => boolean | U_2;
    orElseLazyGet: <U_3>(u: import("../types").ParameterlessLazyLoad<U_3>) => boolean | U_3;
    orElseGetUndefined: () => boolean | undefined;
    orElseGetNull: () => boolean | null;
    orElseThrowDefault: (name: string) => boolean;
    orElseThrowCustom: (message: string) => boolean;
};
declare const parseAsNumber: (t: unknown) => {
    inRangeOf: (min: number, max: number) => Readonly<{
        orElseGet: <U>(u: U) => number | U;
        orElseLazyGet: <U_1>(u: import("../types").ParameterlessLazyLoad<U_1>) => number | U_1;
        orElseGetUndefined: () => number | undefined;
        orElseGetNull: () => number | null;
        orElseThrowDefault: (name: string) => number;
        orElseThrowCustom: (message: string) => number;
    }>;
    exactlyAs: <N extends number>(n: N) => {
        orElseGet: <U_2>(u: U_2) => N | U_2;
        orElseLazyGet: <U_3>(u: import("../types").ParameterlessLazyLoad<U_3>) => N | U_3;
        orElseGetUndefined: () => N | undefined;
        orElseGetNull: () => N | null;
        orElseThrowDefault: (name: string) => N;
        orElseThrowCustom: (message: string) => N;
    };
    orElseGet: <U>(u: U) => number | U;
    orElseLazyGet: <U_1>(u: import("../types").ParameterlessLazyLoad<U_1>) => number | U_1;
    orElseGetUndefined: () => number | undefined;
    orElseGetNull: () => number | null;
    orElseThrowDefault: (name: string) => number;
    orElseThrowCustom: (message: string) => number;
};
/**
 * Although it can be used to parse anything, this is recommended to be used to parse as a specified non-object type
 * @returns the Options object
 */
declare const parseAsCustomType: <T>(t: unknown, isParseable: (t: any) => boolean) => Readonly<{
    orElseGet: <U>(u: U) => T | U;
    orElseLazyGet: <U_1>(u: import("../types").ParameterlessLazyLoad<U_1>) => T | U_1;
    orElseGetUndefined: () => T | undefined;
    orElseGetNull: () => T | null;
    orElseThrowDefault: (name: string) => T;
    orElseThrowCustom: (message: string) => T;
}>;
export { parseAsBoolean, parseAsString, parseAsNumber, parseAsNull, parseAsCustomType, };
