export default class ParseError extends Error {
    constructor(message) {
        super(message);
    }
    static default = ({ name, value, expectedType, }) => new ParseError(`expect "${name}": ${JSON.stringify(value, undefined, 4)} to have type "${expectedType}", actual type is "${Array.isArray(value) ? 'array' : typeof value}" instead`);
    static custom = (message) => new ParseError(message);
}
//# sourceMappingURL=Parser.js.map