import ParseError from '../error/Parser.js';
const orElseThrow = (t, isMatchingType, error) => {
    if (isMatchingType()) {
        return t();
    }
    throw error();
};
const createOptions = ({ t, expectedType, isMatchingType, }) => ({
    orElseGetNull: () => (!isMatchingType() ? null : t()),
    orElseGetUndefined: () => (!isMatchingType() ? undefined : t()),
    orElseGet: (a) => (!isMatchingType() ? a : t()),
    orElseLazyGet: (a) => (!isMatchingType() ? a() : t()),
    orElseThrowCustom: (message) => orElseThrow(t, isMatchingType, () => ParseError.custom(message)),
    orElseThrowDefault: (name) => orElseThrow(t, isMatchingType, () => ParseError.default({
        name,
        expectedType,
        value: t(),
    })),
});
const createExact = ({ t, e, expectedType, }) => createOptions({
    t: () => t,
    expectedType,
    isMatchingType: () => t === e,
});
export { createOptions, createExact };
//# sourceMappingURL=index.js.map